Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::Scorer Class Referenceabstract

Common scoring functionality for different types of queries. More...

`#include <Scorer.h>`

Inheritance diagram for Lucene::Scorer:

## Public Member Functions

| Scorer (const SimilarityPtr &similarity)
| Constructs a Scorer. More...
virtual | ~Scorer ()
virtual String | getClassName ()
boost::shared_ptr< Scorer > | shared_from_this ()
SimilarityPtr | getSimilarity ()
| Returns the Similarity implementation used by this scorer. More...
virtual void | score (const CollectorPtr &collector)
| Scores and collects all matching documents. More...
virtual double | score ()=0
| Returns the score of the current document matching the query. Initially invalid, until nextDoc() or advance(int32_t) is called the first time, or when called from within Collector#collect. More...
Public Member Functions inherited from Lucene::DocIdSetIterator
virtual | ~DocIdSetIterator ()
boost::shared_ptr< DocIdSetIterator > | shared_from_this ()
virtual int32_t | docID ()=0
| Returns the following: More...
virtual int32_t | nextDoc ()=0
| Advances to the next document in the set and returns the doc it is currently on, or NO_MORE_DOCS if there are no more docs in the set. More...
virtual int32_t | advance (int32_t target)=0
| Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or NO_MORE_DOCS if there are no more docs in the set. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DocIdSetIterator
static String | _getClassName ()

## Protected Member Functions

virtual bool | score (const CollectorPtr &collector, int32_t max, int32_t firstDocID)
| Collects matching documents in a range. Hook for optimization. Note, firstDocID is added to ensure that nextDoc() was called before this method. More...
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

SimilarityPtr | similarity
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Static Public Attributes inherited from Lucene::DocIdSetIterator
static const int32_t | NO_MORE_DOCS
| When returned by nextDoc(), advance(int) and docID() it means there are no more docs in the iterator. More...

## Detailed Description

Common scoring functionality for different types of queries.

A Scorer iterates over documents matching a query in increasing order of doc Id.

Document scores are computed using a given Similarity implementation.

NOTE: The values NEGATIVE_INFINITY and POSITIVE_INFINITY are not valid scores. Certain collectors (eg TopScoreDocCollector) will not properly collect hits with these scores.

## Constructor & Destructor Documentation

## ◆ Scorer()

Lucene::Scorer::Scorer | ( | const SimilarityPtr & | similarity | ) |

Constructs a Scorer.

Parameters

  similarity | The Similarity implementation used by this scorer.

## ◆ ~Scorer()

virtual Lucene::Scorer::~Scorer | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::Scorer::_getClassName | ( |  | ) |

inline static

## ◆ getClassName()

virtual String Lucene::Scorer::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::DocIdSetIterator.

Reimplemented in Lucene::CountingConjunctionSumScorer, Lucene::CountingDisjunctionSumScorer, Lucene::SingleMatchScorer, Lucene::BucketScorer, Lucene::PayloadNearSpanScorer, Lucene::BooleanScorer2, Lucene::BooleanScorer, Lucene::ScoreCachingWrappingScorer, Lucene::PhraseScorer, Lucene::TermScorer, Lucene::ReqExclScorer, Lucene::DisjunctionMaxScorer, Lucene::DisjunctionSumScorer, Lucene::ReqOptSumScorer, Lucene::ConjunctionScorer, Lucene::SpanScorer, Lucene::ExactPhraseScorer, and Lucene::SloppyPhraseScorer.

## ◆ getSimilarity()

SimilarityPtr Lucene::Scorer::getSimilarity | ( |  | ) |

Returns the Similarity implementation used by this scorer.

## ◆ score() [1/3]

virtual void Lucene::Scorer::score | ( | const CollectorPtr & | collector | ) |

virtual

Scores and collects all matching documents.

Parameters

  collector | The collector to which all matching documents are passed.

Reimplemented in Lucene::BooleanScorer, Lucene::BooleanScorer2, Lucene::DisjunctionSumScorer, Lucene::TermScorer, and Lucene::ScoreCachingWrappingScorer.

## ◆ score() [2/3]

virtual double Lucene::Scorer::score | ( |  | ) |

pure virtual

Returns the score of the current document matching the query. Initially invalid, until nextDoc() or advance(int32_t) is called the first time, or when called from within Collector#collect.

Implemented in Lucene::CountingConjunctionSumScorer, Lucene::CountingDisjunctionSumScorer, Lucene::SingleMatchScorer, Lucene::BucketScorer, Lucene::PayloadNearSpanScorer, Lucene::BooleanScorer2, Lucene::BooleanScorer, Lucene::DisjunctionSumScorer, Lucene::TermScorer, Lucene::PhraseScorer, Lucene::DisjunctionMaxScorer, Lucene::ReqExclScorer, Lucene::ScoreCachingWrappingScorer, Lucene::ReqOptSumScorer, Lucene::SpanScorer, and Lucene::ConjunctionScorer.

## ◆ score() [3/3]

virtual bool Lucene::Scorer::score | ( | const CollectorPtr & | collector,
|  | int32_t | max,
|  | int32_t | firstDocID
| ) |  |

protected virtual

Collects matching documents in a range. Hook for optimization. Note, firstDocID is added to ensure that nextDoc() was called before this method.

Parameters

  collector | The collector to which all matching documents are passed.
  max | Do not score documents past this.
  firstDocID | The first document ID (ensures nextDoc() is called before this method.

Returns
  true if more matching documents may remain.

Reimplemented in Lucene::DisjunctionSumScorer, Lucene::TermScorer, Lucene::BooleanScorer2, Lucene::BooleanScorer, and Lucene::ScoreCachingWrappingScorer.

## ◆ shared_from_this()

boost::shared_ptr< Scorer > Lucene::Scorer::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ similarity

SimilarityPtr Lucene::Scorer::similarity

protected

The documentation for this class was generated from the following file:

- Scorer.h

clucene.sourceforge.net